// Julia.java

import ch.aplu.util.*;
import java.awt.Color;

public class Julia
{
  private final int maxIteration = 100;
  private final double maxNorm = 50;
  private final double step = 0.008;
  private final double border = 2;
  private GPanel p = new GPanel( -2, 2, -2, 2 );

  public Julia()
  {
    p.enableRepaint( false );//schaltet das automatische Repaint der Grafikbefehle des GPanels aus
    Complex c = new Complex(-0.5, -0.5);
    Complex z0 = new Complex(-border, - border);
    Complex z;
    Complex cStep = new Complex(step, 0 );
    int it;
    while (z0.getImg() < border) // Scan in imaginary direction
    {
      z0 = new Complex(-border, z0.getImg() + step);
      while (z0.getReal() < border) // Scan in real direction
      {
         z0 = Complex.add(z0, new Complex(step, 0));
         z =  z0;
         it = 0;
         while (z.modulus() < maxNorm && it < maxIteration)
         {
            Complex temp = Complex.multiply(z, z); // z = z^2 + c
            z = Complex.add(temp, c);
            it++;
         }
         if (it < 3)
            putPixel( z0, Color.gray );
         else 
           if (it < 4)
             putPixel(z0, Color.green);
           else 
             if (it < 5)
               putPixel(z0, Color.red);
             else 
               if (it < 10)
                 putPixel(z0, Color.blue);
               else 
                 if (it < 15)
                   putPixel(z0, Color.yellow);
                 else 
                   if (it < 20)
                     putPixel(z0, Color.cyan);
                   else 
                     if (it < 25)
                       putPixel(z0, Color.lightGray);
                     else 
                       if (it < 30)
                         putPixel(z0, Color.green);
                       else 
                         if (it < 35)
                           putPixel(z0, Color.magenta);
                         else
                           putPixel( z0, Color.black );
      }
      p.repaint();   // zeichnet linienweise
    }
  }

  private void putPixel(Complex z, Color c)
  {
    p.color(c);
    p.point(z.getReal(), z.getImg());
  }

  public static void main(String[] args)
  {
    new Julia();
  }
}
